using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO; 
namespace Asynchronization_Socket
{
    public partial class Form1 : Form
    {
        byte[] buffer = new byte[1024];
        Socket new_sock;
        Socket rec_sock;
        Socket client_sock;
        Socket sock;

        void end_rec(IAsyncResult ir)
        {
            try
            {
            rec_sock.EndReceive(ir);
            string rec_msg = System.Text.UnicodeEncoding.Unicode.GetString(buffer);
            listBox1.Items.Add(rec_msg);
            rec_sock.BeginReceive(buffer, 0, 1024, SocketFlags.None, new AsyncCallback(end_rec), new_sock);
            }
            catch (Exception) { }
        }

        void end_accept(IAsyncResult ir)
        {
            try
            {
                new_sock = ((Socket)(ir.AsyncState));
                rec_sock = new_sock.EndAccept(ir);
                rec_sock.BeginReceive(buffer, 0, 1024, SocketFlags.None, new AsyncCallback(end_rec), new_sock);
            }
            catch (Exception) { }
        }

        void end_conncet(IAsyncResult ir)
        {
            try
            {
            client_sock.EndConnect(ir);
        }
        catch (Exception) { }
        }

        void end_send(IAsyncResult ir)
        {
            try
            {
            client_sock.EndSend(ir);
        }
        catch (Exception) { }
        } 



        public Form1()
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false; 
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                new_sock.Close();
                sock.Close();
            }
            catch (Exception) { }
            button1.Enabled = true;
            button2.Enabled = false;
        }
      
        void Starting_Server()
        {
            try
            {
            sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            sock.Bind(new IPEndPoint(IPAddress.Any, 5000));
            sock.Listen(-1);
            sock.BeginAccept(new AsyncCallback(end_accept), sock);
        }
        catch (Exception) { }
         }

        void Client_Conncetion()
        {
            try
            {
            client_sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            client_sock.BeginConnect(new IPEndPoint(IPAddress.Parse(textIP.Text), 5000), new AsyncCallback(end_conncet), client_sock);
        }
        catch (Exception) { }
        }
        private void button1_Click(object sender, EventArgs e)
        {

            Starting_Server();
            button1.Enabled = false;
            button4.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
               byte[] send_buffer = System.Text.UnicodeEncoding.Unicode.GetBytes(textBox1.Text);
               client_sock.BeginSend(send_buffer, 0, send_buffer.Length, SocketFlags.None, new AsyncCallback(end_send), client_sock);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Starting_Server();

            Client_Conncetion();
            
        }

        private void button4_Click(object sender, EventArgs e)
        {
            Client_Conncetion(); 
            button4.Enabled = false;
            button2.Enabled = true;
        }
    }
}